<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Administrar extends CI_Controller {
	function __construct()
	{
		parent::__construct();
		$this->load->model('cuestionario_model');
		$this->load->model('empresas_model');
		$this->load->model('usuario_model');
		$this->load->helper('mail');
		$this->load->helper('general');
	}

	function index()
	{
	}

	function usuarios($id = null)
	{
		$datos = array();
		$datos['usuarios'] = $this->usuario_model->obtener('usuarios', $id);
		if($id == null){
			$this->load->view('listar_usuarios', $datos);
		} else {
			$datos['usuario'] = $datos['usuarios'][0];
			$datos['usuario_id'] = $id;
			unset($datos['usuarios']);
			$datos['empresas_posibles'] = $this->empresas_model->obtener();
			$datos['encuestas_posibles'] = $this->cuestionario_model->obtener_encuestas_activas();
			if(isset($datos['usuario']['empresa_asociada']) && isset($datos['usuario']['tipo_asociacion'])){
				$contraparte = $this->usuario_model->buscar_contraparte($datos['usuario']['empresa_asociada'], $datos['usuario']['tipo_asociacion']);
				if(sizeof($contraparte) == 1){
					$datos['contraparte'] = $contraparte[0];
				}

				$empresa = $this->empresas_model->obtener($datos['usuario']['empresa_asociada']);
				if(sizeof($empresa) == 1)
					$datos['empresa'] = $empresa[0];
			}

			if(isset($_GET['debug']) && $_GET['debug'] == 'true'){
				echo '<pre>';
				print_r($datos);
				return;
			}
			

			$this->load->view('detalle_usuario', $datos);
		}
	}

	function empresas($id = null)
	{
		$datos = array();
		$empresas = $this->empresas_model->obtener($id);
		if($id == null){
			$datos['empresas'] = $empresas;
			$this->load->view('listar_empresas', $datos);
		} else {
			$datos['empresa'] = $empresas[0];
			$datos['usuarios'] = $this->usuario_model->obtener('usuarios');
			$this->load->view('detalle_empresa', $datos);
		}
	}

	function borrarPerfilUsuario($usuario, $redireccion = null)
	{
		$this->usuario_model->borrar_perfil_usuario($usuario);
		header('location: http://dev.binext.cl/administrar/usuarios/'.$usuario);
	}

	function asociarUsuarioConEmpresa()
	{
		$usuario = $this->input->post('usuario');
		$empresa = $this->input->post('empresa');
		$tipo = $this->input->post('tipo');

		$this->usuario_model->asociar_usuario_con_empresa($usuario, $empresa, $tipo);
		header('location: http://dev.binext.cl/administrar/usuarios/'.$usuario);
	}

	function agregarFormularioAUsuario()
	{

		$formulario = $this->input->post('formulario');
		$usuario = $this->input->post('usuario');
		$us = $this->usuario_model->obtener('usuarios', $usuario);
		$existe = false;
		if(sizeof($us) == 1 && isset($us[0]['encuestas_asignadas'])){
			foreach ($us[0]['encuestas_asignadas'] as $key => $value) {
				if($value->id == $formulario) $existe = true;
			}
		}
		if(!$existe) 
			$this->usuario_model->agregar_formulario_a_usuario($usuario, $formulario);
		header('location: http://dev.binext.cl/administrar/usuarios/'.$usuario);
	}

	function habilitarRespuesta($usuario, $nuevo_estado)
	{
		if($nuevo_estado == 'si' || $nuevo_estado == 'no'){
			$estado = true;
			
			if($nuevo_estado == 'no') $estado = false;
			$this->usuario_model->habilitar_usuario_responder($usuario, $estado);
		}

		header('location: http://dev.binext.cl/administrar/usuarios/'.$usuario);
	}


}