<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Cuestionario extends CI_Controller {
	function __construct()
	{
		parent::__construct();
		$this->load->model('cuestionario_model');
		$this->load->library('session');
        $this->load->helper('auth');
	}

	public function index()
	{
		header('Location: http://dev.binext.cl/cuestionario/responder');
	}

	public function responder()
	{
		verificarSesion();
	}

	public function usuario()
	{

	}

	public function lala()
	{
		$data = array();
		$cuestionarios = $this->cuestionario_model->get();
		$data['cuestionarios'] = $cuestionarios;
		$this->load->view('responder', $data);
	}

	public function guardarRespuesta($id = null)
	{
		$_res = array();
		$bulk = new MongoDB\Driver\BulkWrite;
		if($id == null){
	        try {
	            $id = new MongoDB\BSON\ObjectId();
	        } catch (Exception $e) {
	        	$_res['resultado'] = 'error';
	        	$_res['error_detalle'] = 'Error al generar ID';
	        	echo json_encode($_res);
	            return false;
	        }
		} else {
			try {
	        	$id = new MongoDB\BSON\ObjectId("$id");
	        } catch (Exception $e) {
	        	$_res['resultado'] = 'error';
	        	$_res['error_detalle'] = 'Error al generar ID';
	        	echo json_encode($_res);
	        	return false;
	        }
		}

		$_res['id'] = ((array)$id)['oid'];
		$datos = json_decode($this->input->post('datos'));
		$bulk->update(
		    ['_id' => $id],
		    ['$set' => [
		    	'formulario' => $this->input->post('formulario_actual'), 
		    	'datos' => $datos,
		    	'categoria_actual' => $this->input->post('categoria_actual'),
				'sub_categoria_actual' => $this->input->post('sub_categoria_actual')
		    ]],
		    ['multi' => false, 'upsert' => true]
		);

		if($this->cuestionario_model->update($bulk, 'respuestas'))
			$_res['resultado'] = 'ok';
		else {
			$_res['resultado'] = 'error';
			$_res['error_detalle'] = 'Error al insertar/actualizar';
		}

		echo json_encode($_res);		
	}

	public function obtenerRespuestas($id = null)
	{
		$respuestas = $this->cuestionario_model->get($id, 'respuestas');
		echo json_encode($respuestas);
	}

	public function obtenerCuestionario($id = null)
	{
		$cuestionario = $this->cuestionario_model->get($id);
		echo json_encode($cuestionario);
	}

	public function get($id, $categoria, $sub_categoria)
	{
		$categoria--;
		$sub_categoria--;
		$cuestionario = $this->cuestionario_model->get($id);
		$data = array();
		$data['titulo'] = $cuestionario['categoria'][$categoria]->titulo;
		$data['sub_categoria'] = $cuestionario['categoria'][$categoria]->sub_categoria[$sub_categoria];
		echo json_encode($data);
	}

	public function ver($formulario, $categoria, $sub_categoria)
	{
		$data = array();
		if(isset($_GET['code'])) $data['code'] = $_GET['code'];
		else $data['code'] = 'false';
		$data['categoria'] = $categoria;
		$data['sub_categoria'] = $sub_categoria;
		$data['formulario'] = $formulario;
		$this->load->view('cuestionario', $data);
	}

	public function listar()
	{
		$data = array();
		$data['cuestionarios'] = $this->cuestionario_model->get();
		$this->load->view('listar', $data);
	}

	public function generar($id_encuesta)
	{
		$data = array();
		echo 'asdasd';
		return;
		$data['cuestionario'] = $this->cuestionario_model->get($id_encuesta);
		$this->load->view('generar', $data);
	}

	public function cerrarCuestionario($id)
	{
		$bulk = new MongoDB\Driver\BulkWrite;
		$_id = null;
        try {
            $_id = new MongoDB\BSON\ObjectId("$id");
        } catch (Exception $e) {
        	echo json_encode(array('resultado' => 'error'));
            return false;
        }

        $bulk->update(
		    ['_id' => $_id],
		    ['$set' => ['terminado' => true]],
		    ['multi' => false, 'upsert' => false]
		);

		if($this->cuestionario_model->update($bulk, 'respuestas')){
			echo json_encode(array('resultado' => 'ok'));
		}
	}

	public function nuevoCuestionario()
	{
		$_id = new MongoDB\BSON\ObjectId;

		$bulk = array(
			"fecha" => $_POST['anio'],
			"mes" => $_POST['mes'],
			"tipo" => $_POST['tipo'],
			"_id" => $_id,
			"categoria" => array()
		);

		$this->cuestionario_model->insert($bulk);
		header('Location: http://dev.binext.cl/cuestionario/listar');
	}

	public function modificar($id)
	{
		$bulk = new MongoDB\Driver\BulkWrite;
		$_id = null;
        try {
            $_id = new MongoDB\BSON\ObjectId("$id");
        } catch (Exception $e) {
        	echo json_encode(array('resultado' => 'error'));
            return false;
        }

		$contenido = json_decode($_POST['contenido']);

		if($_POST['tipo'] == 'nuevo'){
			$data = array('titulo' => $_POST['categoria']);
			$data['sub_categoria'] = array();
			array_push($data['sub_categoria'], array('titulo' => $_POST['sub_categoria'], 'preguntas' => $contenido));
			
			$bulk->update(
			    ['_id' => $_id],
			    ['$push' => ['categoria' => $data]],
			    ['multi' => false, 'upsert' => false]
			);

			if($this->cuestionario_model->update($bulk)){
				echo json_encode(array('resultado' => 'ok'));
			}

		} else if($_POST['tipo'] == 'nueva_categoria'){
			$data = array('titulo' => $_POST['nombre_categoria'], 'preguntas' => $contenido);

			$bulk->update(
			    ['_id' => $_id],
			    ['$push' => ['categoria.'.$_POST['id_categoria'].'.sub_categoria' => $data]],
			    ['multi' => false, 'upsert' => false]
			);

			if($this->cuestionario_model->update($bulk)){
				echo json_encode(array('resultado' => 'ok'));
			}
		} else if($_POST['tipo'] == 'modificar_categoria'){
			$data = array('titulo' => $_POST['nombre_sub_categoria'], 'preguntas' => $contenido);

			$bulk->update(
			    ['_id' => $_id],
			    ['$set' => ['categoria.'.$_POST['indice_categoria'].'.sub_categoria.'.$_POST['indice_sub_categoria'] => $data]],
			    ['multi' => false, 'upsert' => false]
			);

			if($this->cuestionario_model->update($bulk)){
				echo json_encode(array('resultado' => 'ok'));
			}
		} else {

		}
	}

	public function detalle($id, $categoria, $s_cat)
	{
		$categoria--;
		$s_cat--;
		
		$resultado = $this->cuestionario_model->get($id);
		$form = $resultado['categoria'][$categoria];

		$sub_categoria = $form->sub_categoria[$s_cat];

		echo '<h2>'.$form->titulo.'</h2>';
		echo '<h3>'.$sub_categoria->titulo.'</h3>';


		foreach ($sub_categoria->preguntas as $key => $value) {
			echo str_replace('p', '', $value->id).'.- '.$value->pregunta.'<br/>';
			switch ($value->tipo) {
				case 'seleccion':
					echo '<table border="1" style="width:50%">';
					foreach ($value->respuestas as $skey => $svalue) {
						echo '
						<tr>
							<td style="width: 80px;"><input type="radio" name="'.$value->id.'" value="'.$svalue->r.'"></td>
							<td>'.$svalue->r;
							if(isset($svalue->puntaje)) echo ' ('.$svalue->puntaje.')';
							echo '</td> 
						</tr>';
					}
					echo '</table>';					
					break;
				
				case 'matriz':
					//print_r($value->preguntas_matriz[0]->respuestas);
					echo '<table border="1" style="width:50%">';
					$cant_respuestas = sizeof($value->preguntas_matriz[0]->respuestas);
					echo '<tr><td></td>';
					foreach ($value->preguntas_matriz[0]->respuestas as $skey => $svalue) {
						echo '<td style="width: 80px;">'.$svalue->r.'</td>';
					}
					echo '</tr>';

					foreach ($value->preguntas_matriz as $skey => $svalue) {						
						echo '<tr>';
						echo '<td>'.$svalue->pregunta.'</td>';
						for ($i=0; $i < $cant_respuestas; $i++) { 
							echo '<td><input type="radio" name="'.$svalue->id.'" value=""></td>';
						}
						echo '</tr>';
					}

					echo '</table>';
					break;

				case 'valor':
					echo '<table border="1" style="width:50%">';
					foreach ($value->respuestas as $skey => $svalue) {
						echo '
						<tr>
							<td style="width: 80px;"><input style="width: 80px;" type="number" name="'.$value->id.'" value=""></td>
							<td>'.$svalue->r;
							if(isset($svalue->puntaje)) echo ' ('.$svalue->puntaje.')';
							echo '</td> 
						</tr>';
					}
					echo '</table>';
					break;
				case 'entrada-numerico':
					echo '<input style="width: 50%" type="number">';
					break;
				default:
					# code...
					break;
			}

			echo '<hr/>';
		}


		//echo '--------------------------------<pre>';
		//print_r($sub_categoria);
	}
}
