<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Mongo {
	private $manager;
	private $db = 'idias.';
	function __construct()
	{
		$this->manager = new MongoDB\Driver\Manager("mongodb://localhost:27017");
		// $this->manager = new MongoDB\Driver\Manager("mongodb://".rawurlencode("mongoadmin:160690spider@172.24.0.2:27017"));

		
	}

    function query($coleccion, $filter = [], $options = [])
	{
		$query = new MongoDB\Driver\Query($filter, $options);
		$rows = null;
		try{
			$rows = $this->manager->executeQuery($this->db.$coleccion, $query);
		} catch (MongoDB\Driver\Exception\AuthenticationException $e) {
			echo '<pre>';
			print_r($e);
		}
		$rows->setTypeMap(['root' => 'array']);
		return $rows->toArray();
	}

	function insertar($coleccion, $objeto)
	{
		$bulk = new MongoDB\Driver\BulkWrite;		
		$_id1 = $bulk->insert($objeto);
		$result = $this->manager->executeBulkWrite($this->db.$coleccion, $bulk);
		return $result->getInsertedCount();
	}

	function modificar($coleccion, $id, $bulk)
	{
		$result = $this->manager->executeBulkWrite($this->db.$coleccion, $bulk);
		return $result->isAcknowledged();
	}

	function marcarLeido($coleccion, $id)
	{
		$bulk = new MongoDB\Driver\BulkWrite;
		$_id = null;
        try {
            $_id = new MongoDB\BSON\ObjectId("$id");
        } catch (Exception $e) {
            return false;
        }

		$bulk->update(
		    ['_id' => $_id],
		    ['$set' => ['by_flag_leido' => true]],
		    ['multi' => false, 'upsert' => false]
		);
		$result = $this->manager->executeBulkWrite($db.$coleccion, $bulk);
		return true;
	}
}