<!DOCTYPE html>
<html>
<head>
	<title>Responder</title>
	<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
	<link rel="stylesheet" href="http://dev.binext.cl/css/line-awesome-font-awesome.min.css">
	<style type="text/css">
		.modal-lg {
		    max-width: 80% !important;
		}

		.tbl-ancho {
			width: 80px;
		}
	</style>
</head>
<body>
	<div class="container">
		<div class="row justify-content-md-center" style="padding-top: 30px;">
			<div class="col-md-11" style="border: 1px solid #E4E4E4; border-radius: 4px; padding: 10px;">
				<h3>Encuestas</h3>
				<hr/>
				<div class="row">
					<div class="col-md-8">
						<select id="select-id-cuestionario" class="form-control">
						<?php 
							foreach ($cuestionarios as $key => $value) {
								if(isset($value['activo']) && $value['activo'])
									echo '<option value="'.((array)$value['_id'])['oid'].'">'.$value['fecha'].'-'.$value['mes'].' '.$value['tipo'].'</option>';
							}
						?>
						</select>
					</div>
					<div class="col-md-4">
						<button id="btn-responder-encuesta" class="btn btn-danger btn-block ">Responder nueva encuesta</button>
					</div>
				</div>
				<hr/>
				<h3>Respuestas</h3>	
				<ul class="list-group" id="ul-respuestas">
				</ul>		
			</div>
		</div>

		<div class="modal" tabindex="-1" role="dialog" id="modal-respuesta">
			<div class="modal-dialog modal-dialog-centered modal-lg modal-dialog-scrollable" role="document">
				<div class="modal-content">
					<div class="modal-header">
						<h5 class="modal-title" id="txt-titulo"></h5>
						<button type="button" class="close" data-dismiss="modal" aria-label="Close">
							<span aria-hidden="true">&times;</span>
						</button>
					</div>

					<div class="modal-body">
						<div class="container-fluid">
							<b><h5 id="txt-sub-categoria"></h5></b>
							<div id="contenedor-preguntas"></div>
						</div>
					</div>

					<div class="modal-footer">
						<!--<button id="btn-generar" type="button" class="btn btn-warning float-left">Generar respuestas</button>-->
						<button id="btn-inicio" type="button" class="btn btn-secondary float-left">Inicio <i class="la la-angle-double-right"></i></button>
						<button id="btn-cerrar-cuestionario" class="btn btn-danger float-left">Cerrar cuestionario</button>
						<button id="btn-siguiente-sub-pregunta" type="button" class="btn btn-primary">Siguiente <i class="la la-angle-double-right"></i></button>
					</div>
				</div>
			</div>
		</div>

		<div class="modal" tabindex="-1" role="dialog" id="modal-respuesta-terminada">
			<div class="modal-dialog modal-dialog-centered modal-lg modal-dialog-scrollable" role="document">
				<div class="modal-content">
					<div class="modal-header">
						<h5 class="modal-title" id="txt-titulo"></h5>
						<button type="button" class="close" data-dismiss="modal" aria-label="Close">
							<span aria-hidden="true">&times;</span>
						</button>
					</div>
					<div class="modal-body">
						<h3>Puntaje total: <span id="puntaje-total"></span></h3>
						<hr/>
						<div class="container-fluid" id="contenedor-respuestas">

						</div>
					</div>
					<div class="modal-footer">
					</div>
				</div>
			</div>
		</div>


	</div>
</body>
<script src="https://code.jquery.com/jquery-3.4.1.js" integrity="sha256-WpOohJOqMqqyKL9FccASB9O0KwACQJpFTUBLTYOVvVU=" crossorigin="anonymous"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js" integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1" crossorigin="anonymous"></script>
	<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>
	<script type="text/javascript">
		//
		//	formulario: conjunto de preguntas agrupadas
		//	cuestionario: conjunto de respuestas de un formulario
		//

		// variable global
		// con cuestionarios
		var cuestionarios = {}

		// conjungo de respuestas 
		// con un formulario asociado
		var cuestionario_actual = ''

		// el formulario actual es el conjunto
		// de preguntas
		var formulario_actual = ''

		// indice de categoria global
		var categoria_actual = 0

		// indice de sub categoria global
		var sub_categoria_actual = 0

		// variable global con respuestas
		// generada por generarRespuestas()
		// y guardada en servidor por upsertCuestionario()
		var datos_respuestas = {}

		var dato = {}

		// objeto formulario actual
		var datos_completo = {}

		// objeto formulario actual 
		// en formato json
		var _d = {}

		var saltos_globales_activos = {}

		$(document).ready(() => {

			// guardar/actualizar cuestionario
			// según formulario actual.
			// si el id es existe y es válido lo 
			// enviará a través de la variable
			// cuestionaro_actual			
			function upsertCuestionario()
			{
				var form = new FormData();
				form.append('datos', JSON.stringify(datos_respuestas));
				form.append('formulario_actual', formulario_actual)
				form.append('categoria_actual', categoria_actual)
				form.append('sub_categoria_actual', sub_categoria_actual)

				var settings = {
					async: true,
					crossDomain: true,
					url: `http://dev.binext.cl/cuestionario/guardarrespuesta/${cuestionario_actual}`,
					method: "post",
					processData: false,
					contentType: false,
					mimeType: "multipart/form-data",
					data: form
				}
				 
				$.ajax(settings).done(function (response) {
					let res = JSON.parse(response)
					if(res.resultado == 'ok'){
						cuestionario_actual = res.id
						obtenerRespuestas()
					} else {
						alert(res.error_detalle)
					}
				})
			}

			// obtener estructura de cuestionario
			// con set de preguntas
			//
			// @ _formulario: id de formulario
			// @cargar_respuestas: cargará las respuestas desde el objeto
			//		datos_respuestas
			function obtenerCuestionario(_formulario, cargar_respuestas = false)
			{
				var settings = {
					async: true,
					crossDomain: true,
					url: `http://dev.binext.cl/cuestionario/obtenercuestionario/${_formulario}`,
					method: "get",
					processData: false,
					contentType: false,
					mimeType: "multipart/form-data",
				}
				 
				$.ajax(settings).done(function (response) {
					_d = response
					datos_completo = JSON.parse(response)
					procesarRespuesta()
					if(cargar_respuestas) cargarRespuestasDesdeObjetoRespuestas()
				})
			}

			// obtener todos los 
			// cuestionarios
			function obtenerCuestionarios()
			{
				var settings = {
					async: true,
					crossDomain: true,
					url: `http://dev.binext.cl/cuestionario/obtenercuestionario/`,
					method: "get",
					processData: false,
					contentType: false,
					mimeType: "multipart/form-data",
				}
				 
				$.ajax(settings).done(function (response) {
					cuestionarios = JSON.parse(response)
					obtenerRespuestas()
				})
			}

			// obtener las respuestas
			// de los cuestionarios ya respondidos 
			function obtenerRespuestas()
			{
				$('#ul-respuestas').empty()
				var settings = {
					async: true,
					crossDomain: true,
					url: `http://dev.binext.cl/cuestionario/obtenerrespuestas`,
					method: "get",
					processData: false,
					contentType: false,
					mimeType: "multipart/form-data",
				}
				 
				$.ajax(settings).done(function (response) {
					let respuestas = JSON.parse(response)

					respuestas.forEach(r => {
						let _q = cuestionarios.filter(q => { return q._id.$oid == r.formulario}) 
						if(_q.length > 0){
							let cant = 0;
							_q[0].categoria.forEach(__q => {
								__q.sub_categoria.forEach(__r => {
									cant += __r.preguntas.length
								})
							})

							let resp = 0
							Object.keys(r.datos).forEach(p => {
								if(typeof r.datos[p].respuestas != 'undefined' && r.datos[p].respuestas.length > 0) resp ++
								if(typeof r.datos[p].respuesta != 'undefined') resp ++
							})

							let _li = `<li class="list-group-item">${_q[0].fecha}-${_q[0].mes} ${_q[0].tipo} <b>${resp}/${cant}</b> &nbsp;`							
							
							if(typeof r.terminado != 'undefined' && r.terminado){
								_li += `<button id="${r._id.$oid}" class="btn btn-success btn-cuestionario-ver-respuestas float-right">Ver respuestas</button> &nbsp;`
								_li += `<button style="margin-right: 10px;" id="${r._id.$oid}" class="btn btn-warning btn-cuestionario-continuar float-right">Modificar</button>`
							}
							else
								_li += `<button id="${r._id.$oid}" class="btn btn-primary btn-cuestionario-continuar float-right">Continuar</button>`
							_li += `</li>`
							$('#ul-respuestas').append(_li)
						}
						
					})
				})
			}

			// guardar cambios en el servidor
			function guardarCambiosEnServidor()
			{
				generarRespuestas()
				upsertCuestionario()
			}

			function generarSubRespuestas()
			{
			}

			// funcion que genera las respuestas
			// y las guarda en tipo objeto
			//
			// @imprimir: si las imprime por consola
			function generarRespuestas(imprimir = false)
			{
				dato.sub_categoria.preguntas.forEach(pregunta => {
					datos_respuestas[pregunta.id] = {}
					datos_respuestas[pregunta.id]['pregunta'] = pregunta.pregunta

					switch(pregunta.tipo){
						case 'seleccion-multiple':
							let selected = [];
							$(`.checkbox-seleccion-multiple-${pregunta.id}`).each(function() {
								if($(this).is(":checked"))
							    	selected.push($(this).attr('name'))
							})

							datos_respuestas[pregunta.id]['tipo'] = 'seleccion-multiple'
							if(typeof datos_respuestas[pregunta.id]["respuestas"] == 'undefined')
								datos_respuestas[pregunta.id]["respuestas"] = []

							selected.forEach(_respuesta => {
								let respuesta = pregunta.respuestas.filter(r => {return r.id == _respuesta})
								
								if(respuesta.length == 1){
									let _o = {
										name: respuesta[0].id,
										glosa: respuesta[0].r,
										puntaje: respuesta[0].puntaje
									}

									if(typeof respuesta[0].detalles !== 'undefined'){
										_o['detalles'] = []

										let aux = 0										
										respuesta[0].detalles.forEach(x => {
											let valor = $(`#pregunta-detalle-${pregunta.id}-${aux}`).val()
											_o['detalles'].push({label: x.label, valor: valor})
											aux++

										})
									}

									if(typeof respuesta[0].extendida != 'undefined' && respuesta[0].extendida)
									{
										datos_respuestas[pregunta.id]["extendidas"] = []
										let _cant = pregunta.respuestas.length
										$(`.entrada-extendida-${pregunta.id}`).each(function() {
											let _va = $(this).val()
											if(typeof _va != 'undefined'){
												_va = _va.trim()
												if(_va != '') {
													datos_respuestas[pregunta.id]["extendidas"].push({
														name: `r-${pregunta.id}-${_cant}`,
														glosa: _va,
														puntaje: respuesta[0].puntaje
													})
													_cant++
												}
											}
										})
									}

									datos_respuestas[pregunta.id]["respuestas"].push(_o)
								}
							})
							
							datos_respuestas[pregunta.id]["respuestas"].forEach(p => {
								let y = pregunta.respuestas.filter(r => {return r.id == p.name})
								if(y.length == 1){
									y = y[0]

									if(typeof y.condicion != 'undefined'){
										switch(y.condicion){
											case 'pregunta':
												datos_respuestas[pregunta.id]["sub_preguntas"] = []
												y.condicion_detalle.forEach(x => { 
													generarSubRespuestas(x, pregunta.id)
												})

												break;
											case 'salto':
												break;
										}
									}
								}
							})
							break;
						case 'seleccion':
							datos_respuestas[pregunta.id]['tipo'] = 'seleccion'
							let _va = $(`input[name=${pregunta.id}]:checked`).val()
							if(typeof _va != 'undefined') {
								let respuesta = pregunta.respuestas.filter(r => {return r.id == _va})

								if(respuesta.length == 1){
									datos_respuestas[pregunta.id]["respuesta"] = {
										id: _va,
										glosa: respuesta[0].r,
										puntaje: respuesta[0].puntaje
									}

									if(typeof respuesta[0].detalles != 'undefined'){
										datos_respuestas[pregunta.id]["respuesta"]['detalles'] = []
										aux = 0
										respuesta[0].detalles.forEach(d => {
											
											let _v = $(`#pregunta-detalle-${respuesta[0].id}-${aux}`).val()
											datos_respuestas[pregunta.id]["respuesta"]['detalles'].push({
												label: d.label,
												valor: _v
											})
											aux++
										})
									}

									if(typeof respuesta[0].condicion != 'undefined'){
										switch(respuesta[0].condicion){
											case 'pregunta':
												datos_respuestas[pregunta.id]["sub_preguntas"] = []
												respuesta[0].condicion_detalle.forEach(x => {
													generarSubRespuestas(x, pregunta.id, respuesta[0].id)
												})
												break;
											default:
												console.log(`[i] xsr ${respuesta[0].condicion}`)
												break;
										}
									}
								}
							}							
							
							break;
						case 'seleccion-numerica':
						case 'seleccion-texto':
							datos_respuestas[pregunta.id]['tipo'] = 'seleccion-texto'
							datos_respuestas[pregunta.id]["respuestas"] = []
							pregunta.respuestas.forEach(respuesta => {
								let _va = $(`input[name=${respuesta.id}]`).val()
								if(typeof _va != 'undefined'){
									_va = _va.trim()
									if(_va != ''){
										datos_respuestas[pregunta.id]["respuestas"].push({
											name: respuesta.id,
											glosa: respuesta.r,
											valor: _va,
											puntaje: respuesta.puntaje
										})
									}
								}
							})
							break;
						case 'matriz':
							datos_respuestas[pregunta.id]['tipo'] = 'matriz'
							datos_respuestas[pregunta.id]["respuestas"] = []
							pregunta.preguntas_matriz.forEach(pregunta_matriz => {

								if(typeof pregunta_matriz.extendida != 'undefined' && pregunta_matriz.extendida){
									datos_respuestas[pregunta.id]["extendidas"] = []
									$(`.entrada-extendida-${pregunta.id}`).each(function(){
										let _glosa = $(this).val()
										if(typeof _glosa != 'undefined'){
											_glosa = _glosa.trim()
											if(_glosa != ''){
												let id = $(this).attr('id').split('_')
												let _val = $(`input[name='r-${pregunta.id}-${id[3]}-ext']:checked`).val()
												if(typeof _val != 'undefined'){
													let x = _val.split('-')
													let _x = pregunta_matriz.respuestas[parseInt(x[3])]
													if(typeof _x !== 'undefined'){

														datos_respuestas[pregunta.id]["extendidas"].push({
															glosa: _x.r,
															name: `r-${pregunta.id}-${id[3]}-ext`,
															pregunta: _glosa,
															puntaje: _x.valor,
															valor: _val
														})
													}
												}
											}
										}
									})
								}

								let _va = $(`input[name=${pregunta_matriz.id}]:checked`).val()
								if(typeof _va != 'undefined'){
									let _pre = pregunta_matriz.respuestas.filter(_p => {return _p.id == _va})
									if(_pre.length == 1){

										if(typeof pregunta_matriz.extendida == 'undefined'){
											datos_respuestas[pregunta.id]["respuestas"].push({
												name: pregunta_matriz.id,
												valor: _pre[0].id,
												puntaje: _pre[0].valor,
												glosa: _pre[0].r,
												pregunta: pregunta_matriz.pregunta
											})
										} else {

											let _i = pregunta_matriz.id.replace('r-', '').replace('-', '_')
											let _p = $(`#entrada_extendida_${_i}_matriz`).val()
											if(_p != ''){
												datos_respuestas[pregunta.id]["respuestas"].push({
													name: pregunta_matriz.id,
													valor: _pre[0].id,
													puntaje: _pre[0].valor,
													glosa: _pre[0].r,
													pregunta: _p
												})
											}
											
										}
										
									} else {
										
									}
								} else {
									let _va = $(`input[name=${pregunta_matriz.id}-ext]:checked`).val()
									console.log('extendida', _va)
								}
							})
							break;
						case 'entrada-numerico':
						case 'entrada-text':
							datos_respuestas[pregunta.id]['tipo'] = 'entrada-text'
							let _v = $(`input[name=${pregunta.id}]`).val()
							datos_respuestas[pregunta.id]["respuesta"] = {
								name: pregunta.id,
								valor: _v
							}
							break;
						default:
							console.log(pregunta.tipo + ' sin implementación<')
					}
				})

				//if(imprimir)
					console.log('[i] respuestas cuestionario: ', datos_respuestas)
			}

			function generarSubRespuestas(pregunta, padre, respuesta)
			{
				let _f = JSON.parse(_d)
				_f = _f.categoria[categoria_actual].sub_categoria[sub_categoria_actual].preguntas
				
				switch(pregunta.tipo){
					case 'seleccion':
						let _va = $(`input[name=${pregunta.id}]:checked`).val()
						if(typeof _va != 'undefined'){
							let _g = ''
							let _p = 0
							let p = pregunta.respuestas.filter(r => { return r.id == _va})

							if(p.length == 1) {
								$(`#detalle-${p[0].id}`).fadeOut()

								_g = p[0].r
								_p = p[0].puntaje

								let _o = {
									pregunta: pregunta.pregunta,
									id: pregunta.id,
									auxiliar_respuesta: respuesta,
									tipo: 'seleccion',
									respuesta: {
										id: _va,
										glosa: _g,
										puntaje: _p
									}
								}

								if(typeof p[0].detalles != 'undefined'){
									console.log('detalles!')
									$(`#detalle-${p[0].id}`).fadeIn()
									_o.respuesta['detalles'] = []
									let aux = 0
									p[0].detalles.forEach(y => {
										let _valor = $(`#pregunta-detalle-${p[0].id}-${aux}`).val()
										_o.respuesta['detalles'].push({
											label: y.label,
											valor: _valor
										})
										aux++
									})
								} 

								datos_respuestas[padre]["sub_preguntas"].push(_o)
							}							
						}

						break;
					case 'seleccion-multiple':
						let selected = []
						$(`.checkbox-seleccion-multiple-${pregunta.id}`).each(function() {
							if($(this).is(":checked"))
						    	selected.push($(this).attr('name'))
						})

						let _o = {
							pregunta: pregunta.pregunta,
							id: pregunta.id,
							auxiliar_respuesta: respuesta,
							tipo: 'seleccion-multiple',
							respuestas: []
						}

						selected.forEach(s => {
							let p = pregunta.respuestas.filter(x => { return x.id == s})

							if(p.length == 1){
								let respuesta_multiple = {
									name: p[0].id,
									glosa: p[0].r,
									puntaje: p[0].puntaje
								}

								if(typeof p[0].detalles != 'undefined'){
									respuesta_multiple['detalles'] = []
									let aux = 0

									p[0].detalles.forEach(y => {
										let _valor = $(`#pregunta-detalle-${p[0].id}-${aux}`).val()
										respuesta_multiple['detalles'].push({
											label: y.label,
											valor: _valor
										})
										aux++
									})
									
								}
								_o.respuestas.push(respuesta_multiple)
							}
						})

						datos_respuestas[padre]["sub_preguntas"].push(_o)

						break;
					case 'matriz':
						let respuestas_matriz = []
						pregunta.preguntas_matriz.forEach(x => {

							var _pregunta = x.pregunta
							var _selector = `input[name="${x.id}"]:checked`

							if(typeof x.extendida != 'undefined'){
								_pregunta = $(`#entrada_extendida_${pregunta.id}_${(pregunta.preguntas_matriz.length)-1}_matriz`).val()
						 		_selector = `input[name="${x.id}"]:checked`
						 	}
						 

						 	let valor = $(_selector).val()
							let _val = x.respuestas.filter(y => { return y.id == valor })

							if(_val.length == 1 && _pregunta != ''){
								let _o = {
									glosa: _val[0].r,
									name: x.id,
									pregunta: _pregunta,
									puntaje: _val[0].valor,
									valor: _val[0].id
								}

								respuestas_matriz.push(_o)
							}
						 })

						let _r = {
							auxiliar_respuesta: '',
							id: pregunta.id,
							pregunta: pregunta.pregunta,
							respuestas: respuestas_matriz,
							tipo: 'matriz'
						}

						datos_respuestas[padre]["sub_preguntas"].push(_r)
						break;
					case 'entrada-texto':
					case 'entrada-text':
					case 'entrada-numerico':
						let valor = $(`input[name=${pregunta.id}]`).val()
						let _tipo = 'entrada-texto'
						if (pregunta.tipo === 'entrada-numerico') _tipo = 'entrada-numerico';
						let _ob = {
							auxiliar_respuesta: '',
							id: pregunta.id,
							pregunta: pregunta.pregunta,
							valor: valor,
							tipo: _tipo
						}

						datos_respuestas[padre]["sub_preguntas"].push(_ob)
						break;
					case 'seleccion-numerica':
					case 'seleccion-texto':
						let _x = {
							auxiliar_respuesta: '',
							id: pregunta.id,
							pregunta: pregunta.pregunta,
							respuestas: [],
							tipo: pregunta.tipo
						}

						pregunta.respuestas.forEach(x => {
							let valor = $(`input[name=${x.id}]`).val()
							_x['respuestas'].push({
								glosa: x.r,
								name: x.id,
								puntaje: x.puntaje,
								valor: valor
							})
						})

						datos_respuestas[padre]["sub_preguntas"].push(_x)
						break;
					default: 
						console.log(`[i] sin implementación: ${pregunta.tipo}`)
						break;
				}
			}

			// cargará las respuestas
			// desde un objeto respuestas
			function cargarRespuestasDesdeObjetoRespuestas(sub_pregunta = false)
			{
				let _f = JSON.parse(_d)
				_f = _f.categoria[categoria_actual].sub_categoria[sub_categoria_actual].preguntas
				Object.keys(datos_respuestas).forEach(k => {
					let pregunta_formulario_actual = {}
					let index = 0
					_f.forEach(form => {
						if(form.id == k){
							pregunta_formulario_actual = form
							pregunta_formulario_actual['index'] = index
						}
						index ++;
					})

					// significa que la pregunta no está
					// en "categoria_actual" y "sub_categoria_actual"
					if(typeof pregunta_formulario_actual.id !== 'undefined'){
						switch(datos_respuestas[k].tipo){
							case 'seleccion':
								if(typeof datos_respuestas[k].respuesta != 'undefined'){
									$(`input:radio[name=${k}]`).val([datos_respuestas[k].respuesta.id])
									
									if(typeof datos_respuestas[k].respuesta.detalles != 'undefined'){
										let aux = 0; 
										datos_respuestas[k].respuesta.detalles.forEach(d => {
											//pregunta-detalle-r-p4-2-0
											//pregunta-detalle-r-p4-2
										 	$(`#pregunta-detalle-${datos_respuestas[k].respuesta.id}-${aux}`).val(d.valor)
										 	aux++
										})
										$(`.pregunta-detalle-${k}`).show()
									}

									// Si es sub_pregunta no tiene que verificar nada
									if(!sub_pregunta){
										if(typeof datos_respuestas[k].sub_preguntas !== 'undefined'){

											// 1. buscar pregunta padre 
											// con la respuesta auxiliar
											// 2. dentro habran muchas respuestas de la sub pregunta
											// que seleccionada. sub_pregunta_requerida solo requerirá
											// de uno solo, es por esto que se reasignara la misma variable
											let sub_pregunta_requerida = {}
											let _id = null

											let _res = pregunta_formulario_actual.respuestas.filter(x => { return x.id == datos_respuestas[k].respuesta.id})
											if(_res.length == 1){
												_res[0].condicion_detalle.forEach(x => {
													$(`#sub_pregunta_${pregunta_formulario_actual.index}`).append(generarPregunta(x, x.id, true, _res[0].id))
												})
											}
											$(`#sub_pregunta_${pregunta_formulario_actual.index}`).show()
											
											datos_respuestas[k].sub_preguntas.forEach(sub_respuesta => {
												//console.log('sub_respuesta:', sub_respuesta)
												cargarSubRespuestasDesdeObjetoRespuestas(sub_respuesta)
												//if(sub_respuesta.tipo == 'seleccion')
												//$(`input:radio[name=${sub_respuesta.id}]`).val([sub_respuesta.respuesta.id])
												//if(sub_respuesta.tipo == 'seleccion-multiple')
												//	console.log('asldjlkasjdlkasjdklasjkl')
											})
										}
									}
								}
								
								break;
							case 'matriz':
								datos_respuestas[k].respuestas.forEach(respuesta => {
									console.log('respuesta x:', respuesta)
									//entrada_extendida_p16_8_matriz
									let _i = respuesta.name.replace('r-', '').replace('-', '_')
									$(`#entrada_extendida_${_i}_matriz`).val(respuesta.pregunta)
									$(`input:radio[name=${respuesta.name}]`).val([respuesta.valor])
								})
								break;
							case 'seleccion-multiple':
								datos_respuestas[k].respuestas.forEach(respuesta => {
									$(`input[name=${respuesta.name}]`).attr("checked", true);
								})

								if(!sub_pregunta){
									if(typeof datos_respuestas[k].sub_preguntas != 'undefined'){
										$(`#sub_pregunta_${pregunta_formulario_actual.index}`).show()
										$(`#sub_pregunta_${pregunta_formulario_actual.index}`).html(`<h2></h2>`)
										
										//return;
										datos_respuestas[k].sub_preguntas.forEach(x => {
											
											//$(`.pregunta-detalle-${k}`).show()
											
											cargarSubRespuestasDesdeObjetoRespuestas(x)
										})
									}
								}
								break;
							case 'seleccion-texto':
								datos_respuestas[k].respuestas.forEach(respuesta => {
									$(`input[name=${respuesta.name}]`).val(respuesta.valor);
								})
								break;
							case 'entrada-text':
								$(`input[name=${datos_respuestas[k].respuesta.name}]`).val(datos_respuestas[k].respuesta.valor);
								break;
							default:							
								break;
						}
					}
					

					if(typeof datos_respuestas[k].respuestas != 'undefined'){
						//console.log(`id_ ${k}, respuestas: `, datos_respuestas[k])
					}
				})
			}

			function cargarSubRespuestasDesdeObjetoRespuestas(sub_respuesta)
			{
				switch(sub_respuesta.tipo){
					case 'seleccion':
						$(`input:radio[name=${sub_respuesta.id}]`).val([sub_respuesta.respuesta.id])
						if(typeof sub_respuesta.respuesta.detalles != 'undefined'){
							aux = 0
							sub_respuesta.respuesta.detalles.forEach(y => {
								let valor = $(`#pregunta-detalle-${sub_respuesta.respuesta.id}-${aux}`).val(y.valor)
								aux++
							})
							$(`#detalle-${sub_respuesta.respuesta.id}`).fadeIn()
						}
						break;
					case 'seleccion-multiple':
						sub_respuesta.respuestas.forEach(x => {
							
							$(`input[name='${x.name}']:checkbox`).prop('checked', true)
							if(typeof x.detalles != 'undefined'){
								aux = 0
								x.detalles.forEach(y => {
									$(`#pregunta-detalle-${x.name}-${aux}`).val(y.valor)
									aux++
								})
							}
						})
						break;
					case 'matriz':
						let aux_matriz_sub_respuesta = 0
						sub_respuesta.respuestas.forEach(x => {
							$(`input[name='${x.name}'][value='${x.valor}']`).attr("checked", true)
							$(`input[name='${x.name}-ext'][value='${x.valor}']`).attr("checked", true)
							let _id = x.name.split('-')
							$(`#entrada_extendida_${_id[1]}-${_id[2]}_${aux_matriz_sub_respuesta}_matriz`).val(x.pregunta)
							aux_matriz_sub_respuesta++
						})
						break;
					case 'entrada-texto':
					case 'entrada-numerico':
						$(`input[name='${sub_respuesta.id}']`).val(sub_respuesta.valor)
						break;
					case 'seleccion-numerica':
					case 'seleccion-texto':
						sub_respuesta.respuestas.forEach(x => {
							$(`input[name='${x.name}']`).val(x.valor)

						})
						break;
					default:
						console.log(`[!] sub pregunta no implementada: ${sub_respuesta.tipo}`)
						break;
				}
			}

			// generá la pregunta en formato html
			// desde un objeto pregunta
			//
			// @pregunta: objeto tipo pregunta
			// @index: indice para ser impreso en el texto
			// @sub_pregunta: agregará un div para 
			// 		sub_preguntas de la pregunta
			//
			// return: devolverá un texto en formato html 
			//		con la pregunta
			function generarPregunta(pregunta, index, sub_pregunta = false, id_respuesta_detalle = null)
			{

				let input_class = 'form-check-input'
				if(sub_pregunta) input_class = 'form-check-input-sub'

				let id_respuesta = ''
				if(id_respuesta_detalle != null){
					id_respuesta = `_${id_respuesta_detalle}`
				}

				let c = `<div style="padding-bottom: 30px;" id="pregunta_${pregunta.id}"><h5>${pregunta.id.replace("p", "").replace('-', '.')}.- ${pregunta.pregunta} </h5>`
				let tipo_seleccion = 0;

				switch(pregunta.tipo){
					case 'seleccion-texto':
						c += `<table class="table table-bordered" >
							  <tbody style="margin: 20px;">`;
							  	sub_index = 0
							  	pregunta.respuestas.forEach(respuesta => {
							  		c += ` <tr>
									      	<td style="width: 300px;">
										      	<div class="">
												  	<input id="respuesta_${sub_index}_${index}" class="form-control" type="text" name="${respuesta.id}">
												</div>
									    	</td>
									      	<td>${respuesta.r} </td>
									    </tr>`
									sub_index++
									})
							    
						c += `</tbody>
							</table>`
						break;
					case 'seleccion-numerica':
						c += `<table class="table table-bordered" >
							  <tbody style="margin: 20px;">`;
							  	sub_index = 0
							  	pregunta.respuestas.forEach(respuesta => {
							  		c += ` <tr>
									      	<td style="width: 150px;">
										      	<div class="">
												  	<input id="respuesta_${sub_index}_${index}" class="form-control" type="number" name="${respuesta.id}" value="">
												</div>
									    	</td>
									      	<td>${respuesta.r}</td>
									    </tr>`
									sub_index++
									})
							    
						c += `</tbody>
							</table>`
						break;
					case 'seleccion-multiple':
						c += `<table class="table table-bordered" >
							  <tbody style="margin: 20px;" id="tabla-${pregunta.id}">`;
							  	sub_index = 0
							  	
							  	pregunta.respuestas.forEach(respuesta => {
							  		
							  		let detalles_respuesta = ``
							  		c += ` <tr>
									      	<td style="width: 80px; text-align: center;">
										      	<div class="form-check">
												  	<input id="respuesta_${sub_index}_${index}" class="${input_class} checkbox-seleccion-multiple-${pregunta.id}" type="checkbox" name="${respuesta.id}"> <!--name="${pregunta.id}"-->
												</div>
									    	</td>
									      	<td>`
									      	c += respuesta.r
									      	if(typeof respuesta.detalles != 'undefined') {
									      		detalles_respuesta = `<div style="display: ;" id="detalle-${respuesta.id}" class="row pregunta-detalle-${pregunta.id}">`
												aux = 0
												respuesta.detalles.forEach(d => {
													let _tipo = 'text'
													if(d.tipo == 'opcion-numerica') _tipo = 'number'
													detalles_respuesta += `
													<div class="col-md-4" style="padding-top: 20px;">
														<div class="row no-gutters">
															<div class="col-md-6">${d.label}</div>
															<div class="col-md-6"><input class="form-control" id="pregunta-detalle-${respuesta.id}-${aux}" type="${_tipo}"></div>
														</div>
													</div>
													`
													aux++
												})
												detalles_respuesta += `</div>`
												c += detalles_respuesta
											}

									c += `</td>
									    </tr>`
									    
									sub_index++
									})


						c += `	<tr class="extendida-${pregunta.id}" style="display: none;" id="pregunta-extendida-${pregunta.id}">
									<td></td>
									<td>
										<div class="input-group mb-3">
										  <input type="text" prop="lalaw" class="form-control entrada-extendida entrada-extendida-${pregunta.id}" id="entrada_extendida_${pregunta.id}_${sub_index}_multiple" placeholder="">
										</div>
									</td>
								</tr>`
							    
						c += `</tbody>
							</table>`
						break;
					case 'seleccion':
						c += `<table class="table table-bordered" >
							  <tbody style="margin: 20px;">`;
							  	sub_index = 0

							  	pregunta.respuestas.forEach(respuesta => {
									let detalles_respuesta = ``
									
									if(typeof respuesta.detalles != 'undefined') {
										detalles_respuesta = `<div style="display: none;" id="detalle-${respuesta.id}" class="row pregunta-detalle-${pregunta.id}">`
										aux = 0
										respuesta.detalles.forEach(d => {
											let _tipo = 'text'
											if(d.tipo == 'opcion-numerica') _tipo = 'number'
											detalles_respuesta += `
											<div class="col-md-4" style="padding-top: 20px;">
												<div class="row no-gutters">
													<div class="col-md-6">${d.label}</div>
													<div class="col-md-6"><input class="form-control" id="pregunta-detalle-${respuesta.id}-${aux}" type="${_tipo}"></div>
												</div>
											</div>
											`
											aux++
										})
										detalles_respuesta += `</div>`
									}
				
							  		c += ` <tr>
									      	<td style="width: 80px; text-align: center;">
										      	<div class="form-check">
												  	<input id="respuesta_${sub_index}_${index}" class="${input_class}" type="radio" name="${pregunta.id}" value="${respuesta.id}">
												  	
												</div>
									    	</td>
									      	<td>${respuesta.r} ${detalles_respuesta} </td>
									    </tr>`
									sub_index++
									})
							    
						c += `</tbody>
							</table>`
						break
					case 'entrada-numerico':
						c += `<input type="number" name="${pregunta.id}" class="form-control" style="width: 100%;">`
						break;
					case 'entrada-text':
						c += `<input type="text" name="${pregunta.id}" class="form-control" style="width: 100%;">`
						break;
					case 'matriz':
						c += `
							<table class="table table-bordered">
								<thead>
									<tr>
										<th ></th>`;											
										pregunta.preguntas_matriz[0].respuestas.forEach(respuestas => {
											c += `<th class="w-20">${respuestas.r}</th>`
										})
						c += `		</tr>
								</thead>
								<tbody id="tabla-${pregunta.id}">`
									sub_index = 0
									pregunta.preguntas_matriz.forEach(_pregunta => {
										c += '<tr>'
										//generarRespuestas()

										if(pregunta.filtro && typeof datos_respuestas[pregunta.pregunta_filtro] != 'undefined'){
											//console.log('[i] pregunta:', pregunta)
											//console.log('[i] _pregunta:', _pregunta)
											//console.log('[i] filtro:', datos_respuestas[pregunta.pregunta_filtro])
										} else {

											if(typeof _pregunta.extendida != 'undefined' && _pregunta.extendida){

												c += `<td><input type="text" class="form-control entrada-extendida entrada-extendida-${pregunta.id}" prop="algo" id="entrada_extendida_${pregunta.id}_${sub_index}_matriz" placeholder="${_pregunta.pregunta}"></td>`
												let _r = 0
												_pregunta.respuestas.forEach(respuesta => {
													c += `<td><input class="" type="radio" name="${_pregunta.id}" value="r-${pregunta.id}-${sub_index}-${_r}"></td>`
													_r++
												})
											}
											else {
												c += `<td>${_pregunta.pregunta}</td>`;

												_pregunta.respuestas.forEach(respuesta => {
													c += `<td><input class="" type="radio" name="${_pregunta.id}" value="${respuesta.id}"></td>`
												})
											}
										}

										c += '</tr>'
										sub_index++
									})

									let _ext = `<tr class="extendida-${pregunta.id}" style="display: non;" id="extendida_${pregunta.id}">
											<td><input class="form-control" placeholder="Otra" type="text"></td>`
									for(let i = 0; i < pregunta.preguntas_matriz[0].respuestas.length; i++){
										_ext += `<td><input class="from-control" type="radio" name="" value=""></td>`
									}

									_ext += '</tr>'
									// Guardar _ext mientras
									// no agregar a c

						c += `</tbody>
							</table>`

						break;
					default:
						console.log(pregunta.tipo)
						break;
				}

				if(!sub_pregunta){
					c += `<div class="sub_pregunta" id="sub_pregunta_${index}"></div>`
				}

				c += '</div>'
				return c
			}

			// cargar cuestionario en div
			function cargarCuestionario()
			{
				$('#txt-titulo').text(dato.titulo)
				$('#txt-sub-categoria').html(dato.sub_categoria.titulo)
				if(dato.sub_categoria.titulo != '') $('#txt-sub-categoria').append('<hr/>')
				$('#contenedor-preguntas').empty()
				$('#contenedor-preguntas').hide()

				index = 0;
				dato.sub_categoria.preguntas.forEach(pregunta => {

					$('#contenedor-preguntas').append(generarPregunta(pregunta, index))
					if(typeof pregunta.respuestas != 'undefined'){
						pregunta.respuestas.forEach(_p => {
							if(typeof _p.sub_preguntas_visibles != 'undefined' && _p.sub_preguntas_visibles && _p.condicion == 'pregunta'){
								console.log('p: ', _p)
								_p.condicion_detalle.forEach(sub_p => {
									$('#contenedor-preguntas').append(generarPregunta(sub_p, sub_p.id, true))
								})
							}
						})
					}

					index++
				})

				$('#contenedor-preguntas').fadeIn()
				$('.sub_pregunta').hide()
			}	

			// verificar si la categoria y la 
			// sub_categoria son válidas
			function procesarRespuesta()
			{
				let _dc = JSON.parse(_d)
				if(typeof _dc.categoria[categoria_actual] !== 'undefined'){
					dato = _dc.categoria[categoria_actual]
					if(typeof _dc.categoria[categoria_actual]['sub_categoria'][sub_categoria_actual] !== 'undefined'){
						dato['sub_categoria'] = _dc.categoria[categoria_actual]['sub_categoria'][sub_categoria_actual]
						//console.log(`[i] categoria actual: ${categoria_actual}`)
						//console.log(`[i] sub categoria actual: ${sub_categoria_actual}`)
						cargarCuestionario()
						$('#btn-cerrar-cuestionario').hide()
						$('#btn-siguiente-sub-pregunta').show()
						$('#modal-respuesta').modal('show')
					} else alert('Falla en esquema 1')
				} else alert('Falla en esquema 2')
			}

			$(document).on('click', '#btn-cerrar-cuestionario', (e) => {
				var settings = {
					async: true,
					crossDomain: true,
					url: `http://dev.binext.cl/cuestionario/cerrarCuestionario/${cuestionario_actual}`,
					method: "get",
					processData: false,
					contentType: false,
					mimeType: "multipart/form-data",
				}
				 
				$.ajax(settings).done(function (response) {
					//console.log('response', response)
					let r = JSON.parse(response)
					if(r.resultado == 'ok'){
						$('#btn-cerrar-cuestionario').hide()
						$('#btn-siguiente-sub-pregunta').show()
						$('#modal-respuesta').modal('hide')
						obtenerRespuestas()
					} else {
						console.log('error al cerrar')
					}
				})
			})

			$(document).on('click', '.form-check-input-sub', e => {
				id = e.target.id.split('_')
			})

			$(document).on('click', '.form-check-input', e => {
				id = e.target.id.split('_')
				
				if(id.length == 3){
					
					let respuesta = id[1]
					var pregunta = id[2]

					let dato_pregunta = dato.sub_categoria.preguntas[pregunta]
					let dato_respuesta = dato_pregunta.respuestas[respuesta]

					// ---- SECCIÓN DE DETALLE ----
					// esconder la sección de detalle para que 
					// sea abierta inmediatamente
					$('.pregunta-detalle-'+dato_pregunta.id).hide()
					$('#sub_pregunta_' + pregunta).hide();
					if(typeof dato_respuesta.detalles != 'undefined'){
						if(dato_pregunta.tipo == 'seleccion-multiple'){
							//if($(`#${e.target.id}`).is(':checked')) $('#detalle-'+dato_respuesta.id).fadeIn()
						}
						else $('#detalle-'+dato_respuesta.id).fadeIn()
					}

					//switch(dato_pregunta.tipo){
					//	case 'seleccion-multiple':
					//	case 'seleccion':
					//		$('#sub_pregunta_' + pregunta).hide();
					//		break;
					//	default:
					//		break;
					//}

					// ---- SECCIÓN DE CONDICIÓN DE PREGUNTA ----
					if(typeof dato_respuesta.condicion != 'undefined'){
						switch (dato_respuesta.condicion){
							case 'salto':
								let salto_desde = parseInt(dato_pregunta.id.replace('p', ''))
								salto_desde++
								let salto_hasta = dato_respuesta.salto_a.replace('p', '')

								if(salto_desde > salto_hasta){
									alert('Error en esquema salto')
								} else {

									saltos_globales_activos[dato_pregunta.id] = []
									
									for(let i = salto_desde; i < salto_hasta; i++){
										saltos_globales_activos[dato_pregunta.id].push(i)
										$('#pregunta_p'+i).hide();
									}
								}
								break;
							case 'pregunta':
								$('#sub_pregunta_' + pregunta).empty();
								if(dato_pregunta.tipo == 'seleccion')
									$('#sub_pregunta_' + pregunta).fadeIn();
								else {
									if($(`input[name='${dato_respuesta.id}']`).is(':checked')) $('#sub_pregunta_' + pregunta).fadeIn();
									else $('#sub_pregunta_' + pregunta).hide();
								}
								//if($(`#${e.target.id}`).is(':checked')) $('#detalle-'+dato_respuesta.id).fadeIn()
								
								//$(`input[name='${x.name}']:checkbox`).prop('checked', true)
								
								//r-p1-2
								//r-p1-2
								dato_respuesta.condicion_detalle.forEach(_p => {
									$('#sub_pregunta_' + pregunta).append(generarPregunta(_p, _p.id, true, dato_respuesta.id));
								})							
								
								break;
						}
					}
				}				
			})

			// continuar con formulario
			// en un lugar dado
			$(document).on('click', '.btn-cuestionario-continuar', e => {
				var settings = {
					async: true,
					crossDomain: true,
					url: `http://dev.binext.cl/cuestionario/obtenerrespuestas/${e.target.id}`,
					method: "get",
					processData: false,
					contentType: false,
					mimeType: "multipart/form-data",
				}
				 
				$.ajax(settings).done(function (response) {
					let r = JSON.parse(response)
					categoria_actual = parseInt(r.categoria_actual)
					sub_categoria_actual = parseInt(r.sub_categoria_actual)
					datos_respuestas = r.datos
					cuestionario_actual = r._id.$oid
					formulario_actual = r.formulario
					obtenerCuestionario(r.formulario, true)
				})
			})

			// mostrar resultados de cuestionario
			$(document).on('click', '.btn-cuestionario-ver-respuestas', e => {
				$('#btn-cerrar-cuestionario').hide()
				$('#btn-siguiente-sub-pregunta').show()
				$('#modal-respuesta-terminada').modal('show')
				var settings = {
					async: true,
					crossDomain: true,
					url: `http://dev.binext.cl/cuestionario/obtenerrespuestas/${e.target.id}`,
					method: "get",
					processData: false,
					contentType: false,
					mimeType: "multipart/form-data",
				}

				$('#contenedor-respuestas').empty()
				 
				$.ajax(settings).done(function (response) {
					let _j = JSON.parse(response)
					let _cant = 0					
					Object.keys(_j.datos).forEach(k => {
						let _tex = `
							<h5>${k}.- ${_j.datos[k].pregunta}</h5>
							<ul class="list-group">`

						switch(_j.datos[k].tipo){
							case 'seleccion':
								_tex += `<li class="list-group-item">${_j.datos[k].respuesta.glosa} <span class="badge badge-primary float-right">${_j.datos[k].respuesta.puntaje}</span></li>`
								_cant += parseInt(_j.datos[k].respuesta.puntaje)
								break;
							case 'seleccion-multiple':
								_j.datos[k].respuestas.forEach(_r => {
									_tex += `<li class="list-group-item">${_r.glosa} <span class="badge badge-primary float-right">${_r.puntaje}</span></li>`
									_cant += parseInt(_r.puntaje)
								})
								break;
							case 'seleccion-texto':
								_j.datos[k].respuestas.forEach(_r => {
									_tex += `<li class="list-group-item">${_r.glosa}: <b>${_r.valor}</b> <span class="badge badge-primary float-right">${_r.puntaje}</span></li>`
									_cant += parseInt(_r.puntaje)
								})
								break;
							case 'matriz':
								_j.datos[k].respuestas.forEach(_r => {
									_tex += `<li class="list-group-item">${_r.pregunta}: <b>${_r.glosa}</b> <span class="badge badge-primary float-right">${_r.puntaje}</span></li>`
									_cant += parseInt(_r.puntaje)
								})
								break;
							case 'entrada-text':
								_tex += `<li class="list-group-item">${_j.datos[k].respuesta.valor} <span class="badge badge-primary float-right"></span></li>`
								
								break;
							default:
								console.log(_j.datos[k].tipo, 'sin implementación')
								break;
						}

						_tex += `</ul>
							<br/>`
						$('#puntaje-total').text(_cant)
						$('#contenedor-respuestas').append(_tex)
					})					
				})
			})

			$(document).on('click', 'input[type=radio]', () => guardarCambiosEnServidor())

			$(document).on('click', 'input[type=checkbox]', () => guardarCambiosEnServidor())

			$(document).on('focusout', 'input[type=text]', () => guardarCambiosEnServidor())

			$(document).on('focusout', 'input[type=number]', () => guardarCambiosEnServidor())

			$('#btn-generar').click(() => {
				generarRespuestas()
				upsertCuestionario()
			})

			$('#btn-inicio').click(() => {
				categoria_actual = 0
				sub_categoria_actual = 0
				procesarRespuesta()
				cargarRespuestasDesdeObjetoRespuestas()
				$('html, body').animate({
					scrollTop: 40
				}, 'slow')
			})

			$('#btn-siguiente-sub-pregunta').click(() => {
				let _sp = JSON.parse(_d)
				let _ca = categoria_actual
				let _sc = sub_categoria_actual
				_sc++			

				if(typeof _sp.categoria[_ca].sub_categoria[_sc] !== 'undefined'){
					sub_categoria_actual = _sc
					procesarRespuesta()
					cargarRespuestasDesdeObjetoRespuestas()
				} else {
					_ca++
					if(typeof _sp.categoria[_ca] !== 'undefined' && typeof _sp.categoria[_ca].sub_categoria[0] !== 'undefined'){
						categoria_actual = _ca
						sub_categoria_actual = 0
						procesarRespuesta()
						cargarRespuestasDesdeObjetoRespuestas()
					} else{
						$('#contenedor-preguntas').empty()
						$('#txt-titulo').text('Cuestionario finalizado')
						$('#txt-sub-categoria').text('')
						$('#contenedor-preguntas').html('<p style="text-align: center;">Cuestionario terminado</p>')
						$('#btn-siguiente-sub-pregunta').hide()
						$('#btn-cerrar-cuestionario').show()
					}
				}
			})
				
			$('#btn-responder-encuesta').click(() => {
				// limpiar datos de las respuestas antes
				// de cargar otros datos
				datos_respuesta = {}
				let id = $('#select-id-cuestionario').val()
				console.log(`[i] formulario_actual: ${id}`)
				formulario_actual = id
				obtenerCuestionario(id)
			})

			obtenerCuestionarios()
		})
	</script>
</html>